#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Aug 13 15:49:47 2022

@author: Ryan Solgi
"""


from tensor_operations import tensor_operations as tp
from matrix_operations import matrix_operations as mp
import numpy as np


class tensor_decomposition:
    
    
    def auto_rank_tt(tensor,epsilon): #epsilon = error ratio [0,1]
        
        t_shape=tensor.shape
        t_dim=len(tensor.shape)
        matrix=tp.unfold(tensor,t_dim-1)
        
        sigma=epsilon*np.linalg.norm(matrix,'fro')/(t_dim-1)
        
        modified_rank_list=[1] 
        counter=1
        tt_list=[]
        r_list=[]
        
        while counter<t_dim:
            
                    r,u,s,vh=mp.error_truncated_svd(matrix,sigma)
                    
                    left_matrix=u[:,:r]
                    right_matrix=np.dot(s[:r,:r],vh[:r,:])
                    
                    
                    
                    
                    tt_list.append(left_matrix)
                    r_list.append(r)
                    m_shape=right_matrix.shape
                    new_shape=[int(m_shape[1]/t_shape[t_dim-1-counter]),r*t_shape[t_dim-1-counter],]
                    matrix=mp.matrix_reshape(right_matrix,new_shape)
                    counter+=1
                    modified_rank_list.append(r)
                    
        modified_rank_list.append(1)
        tt_list.append(right_matrix)
        
        factors_list=[]
        
        for i in range(0,len(tt_list)):
            
                    transpose_core=np.transpose(tt_list[-i-1])
                    core_reshape=np.reshape(transpose_core,(modified_rank_list[-1-i],t_shape[i],modified_rank_list[-1-(i+1)])) 
                    factors_list.append(core_reshape)
                
        return factors_list
    
    
    
            
         
            
    
